$H const.ph

'
'Strukturen
Struct DEVMODE  = DeviceName$(31),dmSpecVersion%,dmDriverVersion%,\
                  dmSize%,dmDriverExtra%,dmFields&,dmOrientation%,\
                  dmPaperSize%,dmPaperLength%,dmPaperWidth%,dmScale%,\
                  dmCopies%,dmDefaultSource%,dmPrintQuality%,dmColor%,\
                  dmDuplex%,dmYResolution%,dmTTOption%,dmCollate%,\
                  dmFormName#(4),dmUnusedPadding%,dmBitsPerPel%,\
                  dmPelsWidth&,dmPelsHeight&,dmDisplayFlags&,\
                  dmDisplayFrequency&,ExtraData#(2000)

Struct Doc_Info1= Docname#(4),OutFile#(4),Datatype#(4)
Struct Size     = Weite&,Hoehe&
'
'Definitionen
DEF GetNDP_STDPrinter(1) Substr$(ReadIni$("WIN.INI","Windows","Device"),@&(1),",")
DEF @GetSysColor(1) !"USER32","GetSysColor"

DEF DeviceCaps(5) ! "WINSPOOL.DRV","DeviceCapabilitiesA"
DEF OpenPrinter(3) !"WINSPOOL.DRV","OpenPrinterA"
DEF ClosePrinter(1) !"WINSPOOL.DRV","ClosePrinter"
DEF DocumentProperties(6) ! "WINSPOOL.DRV","DocumentPropertiesA"
DEF PrinterProperties(2) ! "WINSPOOL.DRV","PrinterProperties"

DEF SDP(2) ! "GDI32","StartDocA"
DEF EDP(1) ! "GDI32","EndDoc"
DEF SPP(1) ! "GDI32","StartPage"
DEF EPP(1) ! "GDI32","EndPage"

DEF LoadImage(6) !"user32","LoadImageA"

DEF CreateCompatibleDC(1) !"gdi32","CreateCompatibleDC"
DEF SelectObject(2) !"gdi32","SelectObject"
DEF BitBlt(9) !"gdi32","BitBlt"
DEF DeleteObject(1) !"gdi32","DeleteObject"

Def GDIDeviceCaps(2) ! "GDI32","GetDeviceCaps"
DEf LockWindowUpdate(1) ! "USER32","LockWindowUpdate"
DEF GetWindowLong(2) ! "USER32","GetWindowLongA"
DEF SetWindowLong(3) ! "USER32","SetWindowLongA"
DEF GetPrivateProfileSection(4) ! "KERNEL32","GetPrivateProfileSectionA"
DEf CreateDC(4) ! "GDI32","CreateDCA"
DEf DeleteDC(1) ! "GDI32","DeleteDC"
DEf TextOut(5) ! "gdi32","TextOutA"
DEf ExtTextOut(8) ! "gdi32","ExtTextOutA"
DEf GetTextExtentPoint32(4) ! "GDI32","GetTextExtentPoint32A"
DEf SetTextAlign(2) ! "GDI32","SetTextAlign"
DEf SetRect(5) ! "USER32","SetRect"
DEf SetBKMode(2) ! "GDI32","SetBkMode"
'Def DeleteObject(1) ! "GDI32","DeleteObject","%","%"
'Definitionen von Thomas Hoelzer
Def GetStockObject(1) !"GDI32","GetStockObject"
Def SetDefaultGUIFont(1) SendMessage(&(1),$30,Val(GetStockObject($11)),1)
'
'Deklarationen
Declare Printer#,Port#,Driver#,DevmodeInput#,Devmodeoutput#,OutPut#,Selstr#
Declare DocInfo1#
Declare Returnbuffer#
Declare DCArray&,DCSize&,DCExtra&,DCDuplex&,DCCopies&
Declare DCTrueType&,DCBins&,DCPapers&,DCOrientation&
Declare DCBinNames&,DCPaperNames&,DC_DATATYPE_PRODUCED&,DC_FILEDEPENDENCIES&
Declare DC_ENUMRESOLUTIONS&,DC_ENUMRESOLUTIONS1&
Declare DCPapersArray&
Declare DCPaperNamesArray&
Declare MyPrinter&,PrinterFont&
Declare Size#

'Funktionen
PROC TEXTHOEHE
Parameters DC&
Declare t$,w&
Dim size#,Size
T$ = "A"
        GetTextExtentPoint32(DC&,addr(t$),@Len(T$),size#)
        W& = size#.hoehe&
        Dispose Size#
        Return w&
ENDPROC
'
PROC TEXTWEITE
Parameters DC&,T$
Declare t$,w&
Dim size#,Size
        GetTextExtentPoint32(DC&,addr(t$),@Len(T$),size#)
        W& = size#.Weite&
        Dispose Size#
        Return w&
ENDPROC
'
Proc Printer_Error
'Fehlermeldung ausgeben
Parameters Errnum%,D$
        Case Errnum% = 1 : @Messagebox("Kein Standard-Drucker im System installiert","Fehler 1",16)
        Case Errnum% = 2 : @Messagebox("Kein Drucker ausgewhlt !","Fehler 2",16)
EndProc

Proc GetPrinterParameter
'DC-Infos's holen
'Parameter Listboxhandle
Parameters LB&
Declare PName$,PDriver$,PPort$,PDC&
Declare PDC&,APX!,APY!,PB!,PH!,POX!,POY!,DPIX!,DPIY!,PBMM!,PHMM!,RMM!
Declare PMAX!,PMAY!,Tech&
Declare Rastercaps&,CurveCaps&,LineCaps&,Polygoncaps&,Textcaps&
Declare POR!,PUR!
Declare PLR!,PRR!

PName$   = GetNDP_STDPrinter(1)
PDriver$ = GetNDP_STDPrinter(3)+".drv"
PPort$   = GetNDP_STDPrinter(2)
Let PDC& = CreateDC(addr(pdriver$),addr(Pname$),addr(Pport$),0)

Tech& = GDIDeviceCaps(PDC&,2)'Technologie
APX!  = GDIDeviceCaps(PDC&,8)'Ausgabebreite in Pixel
APY!  = GDIDeviceCaps(PDC&,10)'AusgabeHoehe in Pixel
PB!   = GDIDeviceCaps(PDC&,110)'Physikalische Breite
PH!   = GDIDeviceCaps(PDC&,111)'Physikalische Hoehe
POX!  = GDIDeviceCaps(PDC&,112)'Offset X
POY!  = GDIDeviceCaps(PDC&,113)'Offset Y
DPIX! = GDIDeviceCaps(PDC&,88)'DPI X
DPIY! = GDIDeviceCaps(PDC&,90)'DPI Y
PBMM! = GDIDeviceCaps(PDC&,4)'Ausgabebreite in mm
PHMM! = GDIDeviceCaps(PDC&,6)'Ausgabehoehe in mm

Rastercaps& = GDIDeviceCaps(PDC&,38)'Rastercaps
Curvecaps&  = GDIDeviceCaps(PDC&,28)'Curvecaps
Linecaps&   = GDIDeviceCaps(PDC&,20)'Linecaps
Polygoncaps&   = GDIDeviceCaps(PDC&,32)'Polygoncaps
Textcaps&   = GDIDeviceCaps(PDC&,34)'Textcaps

@addstring(LB&,"_____________________________")
@addstring(LB&,"Drucker-Technologie")
Case Tech& = 0 : @addstring(LB&,"  - Vector plotter")
Case Tech& = 1 : @addstring(LB&,"  - Raster display")
Case Tech& = 2 : @addstring(LB&,"  - Raster printer")
Case Tech& = 3 : @addstring(LB&,"  - Raster camera")
Case Tech& = 4 : @addstring(LB&,"  - Character stream")
Case Tech& = 5 : @addstring(LB&,"  - Metafile")
Case Tech& = 6 : @addstring(LB&,"  - Display file")
@addstring(LB&,"_____________________________")
@addstring(LB&,"Physikalische Druckerwerte : ")
@addstring(LB&,"Ausgabebreite in Pixel : "+str$(APX!))
@addstring(LB&,"Ausgabehhe in Pixel : "+str$(APY!))
@addstring(LB&,"Physikalische Breite in Pixel : "+str$(PB!))
@addstring(LB&,"Physikalische Hhe in Pixel  :  "+str$(PH!))
@addstring(LB&,"Physikalischer Offset X : "+str$(POX!))
@addstring(LB&,"Physikalischer Offset Y : "+str$(POY!))
@addstring(LB&,"Aufloesung Breite (DPI) : "+str$(DPIX!))
@addstring(LB&,"Aufloesung Hhe (DPI) : "+str$(DPIY!))
@addstring(LB&,"Ausgabebreite in mm : "+str$(PBMM!*10))
@addstring(LB&,"Ausgabehhe in mm : "+str$(PHMM!*10))
@addstring(LB&,"_____________________________")
@addstring(LB&,"Physikalische Blatt-Grenzen :")

@addstring(LB&,"Linker Rand in Pixel : "+STR$(POX!))
@addstring(LB&,"Rechter Rand in Pixel : "+STR$(SUB(SUB(PB!,APX!),POX!)))
@addstring(LB&,"Oberer Rand in Pixel : "+STR$(POY!))
@addstring(LB&,"Unterer Rand in Pixel : "+STR$(SUB(SUB(PH!,APY!),POY!)))

Decimals 1
PLR!=ROUND(MUL(DIV(PBMM!,APX!),POX!),1)
PRR!=ROUND(MUL(DIV(PBMM!,APX!),SUB(SUB(PB!,APX!),POX!)),1)
POR!=ROUND(MUL(DIV(PHMM!,APY!),POY!),1)
PUR!=ROUND(MUL(DIV(PHMM!,APY!),SUB(SUB(PH!,APY!),POY!)),1)
@addstring(LB&,"Linker Rand in mm : "+STR$(PLR!))
@addstring(LB&,"Rechter Rand in mm : "+STR$(PRR!))
@addstring(LB&,"Oberer Rand in mm : "+STR$(POR!))
@addstring(LB&,"Unterer Rand in mm : "+STR$(PUR!))

Decimals 0
@addstring(LB&,"Blattgrsse X in mm : "+STR$(MUL(ADD(ADD(PBMM!,PLR!),PRR!),10)))
@addstring(LB&,"Blattgrsse Y in mm : "+STR$(MUL(ADD(ADD(PHMM!,POR!),PUR!),10)))

@addstring(LB&,"_____________________________")
@addstring(LB&,"RasterCap - Flags :")
@addstring(LB&,"Flags : "+Hex$(Rastercaps&))
Case @AND(Rastercaps&,1) : @addstring(LB&,"  - Bitblt")
Case @AND(Rastercaps&,2) : @addstring(LB&,"  - Banding")
Case @AND(Rastercaps&,4) : @addstring(LB&,"  - Skalierung")
Case @AND(Rastercaps&,8) : @addstring(LB&,"  - Bitmaps > 64K")
Case @AND(Rastercaps&,16) : @addstring(LB&,"  - Windows 2.0 Features")
Case @AND(Rastercaps&,32) : @addstring(LB&,"  - GDI20_STATE")
Case @AND(Rastercaps&,64) : @addstring(LB&,"  - SAVEBITMAP")
Case @AND(Rastercaps&,128) : @addstring(LB&,"  - GetDIBits SetDIBits")
Case @AND(Rastercaps&,256) : @addstring(LB&,"  - Paletten-Spezifikation")
Case @AND(Rastercaps&,512) : @addstring(LB&,"  - SetDIBitsToDevice")
Case @AND(Rastercaps&,1024) : @addstring(LB&,"  - BIGFONT")
Case @AND(Rastercaps&,2048) : @addstring(LB&,"  - StretchBlt")
Case @AND(Rastercaps&,4096) : @addstring(LB&,"  - Floodfill")
Case @AND(Rastercaps&,8192) : @addstring(LB&,"  - StretchDIB")
Case @AND(Rastercaps&,16384) : @addstring(LB&,"  - OP_DX_OUTPUT")
Case @AND(Rastercaps&,32768) : @addstring(LB&,"  - DevBits")

@addstring(LB&,"_____________________________")
@addstring(LB&,"CurveCap - Flags :")
@addstring(LB&,"Flags : "+hex$(Curvecaps&))
Case @AND(Curvecaps&,2) : @addstring(LB&,"  - PIE")
Case @AND(Curvecaps&,4) : @addstring(LB&,"  - PREVENTFULLOPEN")
Case @AND(Curvecaps&,8) : @addstring(LB&,"  - SHOWHELP")
Case @AND(Curvecaps&,16) : @addstring(LB&,"  - WIDE")
Case @AND(Curvecaps&,32) : @addstring(LB&,"  - STYLED")
Case @AND(Curvecaps&,64) : @addstring(LB&,"  - WIDESTYLED")
Case @AND(Curvecaps&,128) : @addstring(LB&,"  - SOLIDCOLOR")
Case @AND(Curvecaps&,256) : @addstring(LB&,"  - ROUNDRECT")

@addstring(LB&,"_____________________________")
@addstring(LB&,"LineCap - Flags :")
@addstring(LB&,"Flags : "+hex$(Linecaps&))
Case @AND(Linecaps&,2) : @addstring(LB&,"  - POLYLINE")
Case @AND(Linecaps&,4) : @addstring(LB&,"  - MARKER")
Case @AND(Linecaps&,8) : @addstring(LB&,"  - POLYMARKER")
Case @AND(Linecaps&,16) : @addstring(LB&,"  - WIDE")
Case @AND(Linecaps&,32) : @addstring(LB&,"  - STYLED")
Case @AND(Linecaps&,64) : @addstring(LB&,"  - WIDESTYLED")
Case @AND(Linecaps&,128) : @addstring(LB&,"  - INTERIORS")

@addstring(LB&,"_____________________________")
@addstring(LB&,"PolygonCap - Flags :")
@addstring(LB&,"Flags : "+hex$(Polygoncaps&))
Case @AND(Polygoncaps&,1) : @addstring(LB&,"  - POLYGON")
Case @AND(Polygoncaps&,2) : @addstring(LB&,"  - RECTANGLE")
Case @AND(Polygoncaps&,4) : @addstring(LB&,"  - TRAPEZOID")
Case @AND(Polygoncaps&,8) : @addstring(LB&,"  - SCANLINE")
Case @AND(Polygoncaps&,16) : @addstring(LB&,"  - WIDE")
Case @AND(Polygoncaps&,32) : @addstring(LB&,"  - STYLED")
Case @AND(Polygoncaps&,64) : @addstring(LB&,"  - WIDESTYLED")
Case @AND(Polygoncaps&,128) : @addstring(LB&,"  - INTERIORS")
Case @AND(Polygoncaps&,256) : @addstring(LB&,"  - POLYPOLYGON")

@addstring(LB&,"_____________________________")
@addstring(LB&,"TextCap - Flags :")
@addstring(LB&,"Flags : "+hex$(Textcaps&))
Case @AND(Textcaps&,1) : @addstring(LB&,"  - OP_CHARACTER")
Case @AND(Textcaps&,2) : @addstring(LB&,"  - OP_STROKE")
Case @AND(Textcaps&,4) : @addstring(LB&,"  - CP_STROKE")
Case @AND(Textcaps&,8) : @addstring(LB&,"  - CR_90")
Case @AND(Textcaps&,16) : @addstring(LB&,"  - CR_ANY")
Case @AND(Textcaps&,32) : @addstring(LB&,"  - SF_X_YINDEP")
Case @AND(Textcaps&,64) : @addstring(LB&,"  - SA_DOUBLE")
Case @AND(Textcaps&,128) : @addstring(LB&,"  - SA_INTEGER")
Case @AND(Textcaps&,256) : @addstring(LB&,"  - SA_CONTIN")
Case @AND(Textcaps&,512) : @addstring(LB&,"  - EA_DOUBLE")
Case @AND(Textcaps&,1024) : @addstring(LB&,"  - IA_ABLE")
Case @AND(Textcaps&,2048) : @addstring(LB&,"  - UA_ABLE")
Case @AND(Textcaps&,4096) : @addstring(LB&,"  - SO_ABLE")
Case @AND(Textcaps&,8192) : @addstring(LB&,"  - RA_ABLE")
Case @AND(Textcaps&,16384) : @addstring(LB&,"  - VA_ABLE")
Case @AND(Textcaps&,32768) : @addstring(LB&,"  - RESERVED")
Case @AND(Textcaps&,65536) : @addstring(LB&,"  - SCROLLBLT")

DeleteDC(PDC&)
EndProc

Proc PrnProp
'Einrichtungs-Dialog des Druckertreibers
Declare Ret&
Dim Printer#,Len(GetNDP_STDPrinter(1))
String Printer#,0=GetNDP_STDPrinter(1)
If Neq(OpenPrinter(Printer#,Addr(MyPrinter&),0),0)
	Ret& = PrinterProperties(%hwnd,MyPrinter&)
	ClosePrinter(MyPrinter&)
EndIf
Dispose Printer#
Return Ret&
EndProc
'
Proc DocProp
'Setzen der Druckereinrichtung
'Parameter : 1 oder 0 fr Systemweit oder Programmweit
Parameters a%
Declare Ret&
Dim Printer#,Len(GetNDP_STDPrinter(1))
Dim DevmodeInput#,Devmode
Dim Devmodeoutput#,Devmode
string Printer#,0=GetNDP_STDPrinter(1)
If Neq(OpenPrinter(Printer#,Addr(MyPrinter&),0),0)
	Case equ(a%,0):Ret& = DocumentProperties(%hwnd,MyPrinter&,Printer#,DevmodeInput#,DevmodeOutput#,12)
	Case equ(a%,1):Ret& = DocumentProperties(%hwnd,MyPrinter&,Printer#,DevmodeInput#,DevmodeOutput#,13)
	ClosePrinter(MyPrinter&)
EndIf
Dispose Printer#
Dispose DevmodeInput#
Dispose Devmodeoutput#
Return Ret&
EndProc
'
Proc GetPrinterCaps
'allgemeine Druckerwerte holen
'Parameter : Listboxhandle
UseCursor 2
Parameters LB&
Declare DM$,x%,a%,ax&,ay&
Clearlist
Dim Printer#,Len(GetNDP_STDPrinter(1))
Dim Port#,Len(GetNDP_STDPrinter(2))
Dim Output#,$FFFF
string Printer#,0=GetNDP_STDPrinter(1)
string Port#,0=GetNDP_STDPrinter(2)
let DCSize& = DeviceCaps(Printer#,Port#,8,0,0)
let DCExtra& = DeviceCaps(Printer#,Port#,9,0,0)
let DCDuplex& = DeviceCaps(Printer#,Port#,7,0,0)
let DCCopies& = DeviceCaps(Printer#,Port#,18,0,0)
let DCOrientation& = DeviceCaps(Printer#,Port#,17,0,0)
let DCBins& = DeviceCaps(Printer#,Port#,6,0,0)
let DCPapers& = DeviceCaps(Printer#,Port#,2,0,0)
let DCTrueType& = DeviceCaps(Printer#,Port#,15,0,0)

Decimals 0
addstring add$("Devmode - Strukturgroesse = ",str$(DCSize&+DCExtra&))
Case DCDuplex& = 1:addstring "Duplex-Printer"
Casenot DCDuplex& = 1:addstring "Kein Duplex-Printer"
addstring add$("Maximale Anzahl der Kopien = ",str$(DCCopies&))
addstring add$("Rotation bei Querformat = ",add$(str$(DCOrientation&),""))
addstring add$("Einzugsschaechte = ",str$(DCBins&))
addstring add$("untersttzte Papierformate = ",str$(DCPapers&))
DC_ENUMRESOLUTIONS& = DeviceCaps(Printer#,Port#,13,0,0)
If DC_ENUMRESOLUTIONS& > -1
addstring "mgliche Auflsungen = "+str$(DC_ENUMRESOLUTIONS&)
Clear Output#
x% = 0
DC_ENUMRESOLUTIONS1& = DeviceCaps(Printer#,Port#,13,Output#,0)
Whilenot x% = DC_ENUMRESOLUTIONS&*4
        Addstring Str$(Long(Output#,x%))+" X "+Str$(Long(Output#,x%+4))+" DPI"
        x% = x% + 4
EndWhile
Endif

Clear Output#
let DC_DATATYPE_PRODUCED& = DeviceCaps(Printer#,Port#,21,Output#,0)
Case DC_DATATYPE_PRODUCED& = -1: addstring "Druckmodus = RAW"
Clear Output#
let DC_FILEDEPENDENCIES& = DeviceCaps(Printer#,Port#,21,Output#,0)
x% = 0
a% = 0
If DC_FILEDEPENDENCIES& <> -1
        Whilenot x% = DC_FILEDEPENDENCIES&
                DM$ = string$(Output#,a%)
                addstring "Druckmodus = "+DM$
                inc x%
                a% = a% + 64
        Endwhile
Endif
Case DCTrueType& = 1 : addstring "TrueType-Optionen = Bitmap"
Case DCTrueType& = 2 : addstring "TrueType-Optionen = Download"
Case DCTrueType& = 8 : addstring "TrueType-Optionen = Download Outline"
Case DCTrueType& = 3 : addstring "TrueType-Optionen = Substitute"
Case DCTrueType& = 6 : addstring "TrueType-Optionen = Bitmap,Download,Substitute"
Case DCTrueType& = 14 : addstring "TrueType-Optionen = Bitmap,Download,Download Outline,Substitute"
SendMessage(LB&,$0184,0,0)
Movelisttolist (lb&)
Dispose Printer#
Dispose Port#
Dispose Output#
EndProc
'
Proc PrinterBins
'Namen der Einzugsschchte holen
'Parameter : Listboxhandle
UseCursor 2
Parameters LB&
Clearlist
Declare x%
Dim Printer#,Len(GetNDP_STDPrinter(1))
Dim Port#,Len(GetNDP_STDPrinter(2))
Dim Output#,$ffff
string Printer#,0=GetNDP_STDPrinter(1)
string Port#,0=GetNDP_STDPrinter(2)
DeviceCaps(Printer#,Port#,12,Output#,0) ' DCBinNames
Whilenot x% = mul(DCBins&,24)
        addstring String$(Output#,x%)
        x% = x%+24
EndWhile
SendMessage(LB&,$0184,0,0)
Movelisttolist (LB&)
Dispose Printer#
Dispose Port#
Dispose Output#
EndProc
'
Proc PaperNames
'Namen der untersttzten Papierformate holen
'Parameter : Listboxhandle
UseCursor 2
Parameters LB&
Clearlist
Declare x%
Dim Printer#,Len(GetNDP_STDPrinter(1))
Dim Port#,Len(GetNDP_STDPrinter(2))
Dim Output#,$ffff
string Printer#,0=GetNDP_STDPrinter(1)
string Port#,0=GetNDP_STDPrinter(2)
DeviceCaps(Printer#,Port#,16,Output#,0) ' DCPaperNames
Whilenot x% = Mul(DCPapers&,64)
        addstring String$(Output#,x%)
        x% = x%+64
EndWhile
SendMessage(LB&,$0184,0,0)
Movelisttolist (LB&)
Dispose Printer#
Dispose Port#
Dispose Output#
EndProc
'
Proc PaperFlags
'Bezeichner fr Papierformate holen
'Parameter : Listboxhandle
UseCursor 2
Parameters LB&
Clearlist
Declare x%
Dim Printer#,Len(GetNDP_STDPrinter(1))
Dim Port#,Len(GetNDP_STDPrinter(2))
Dim Output#,$ffff
string Printer#,0=GetNDP_STDPrinter(1)
string Port#,0=GetNDP_STDPrinter(2)
DeviceCaps(Printer#,Port#,2,Output#,0) ' DCPapers
Whilenot x% = Mul(DCPapers&,2)
        addstring str$(word(Output#,x%))
        x% = x%+2
EndWhile
SendMessage(LB3&,$0184,0,0)
Movelisttolist (LB3&)
Dispose Printer#
Dispose Port#
Dispose Output#
EndProc
'
Proc Akt_Printer_Einstellungen
'aktuelle Druckereinstellung holen
'Parameter : Listboxhandle
UseCursor 2
Parameters LB&,LB2&,LB3&
Declare Nr&,ST$
Clearlist
Dim Printer#,Len(GetNDP_STDPrinter(1))
Dim DevmodeInput#,Devmode
Dim Devmodeoutput#,Devmode
Dim Selstr#,200
string Printer#,0=GetNDP_STDPrinter(1)
If Neq(OpenPrinter(Printer#,Addr(MyPrinter&),0),0)
	DocumentProperties(%hwnd,MyPrinter&,Printer#,DevmodeInput#,DevmodeOutput#,2)
	ClosePrinter(MyPrinter&)
EndIf
Addstring ADD$("Druckername : ",DevmodeInput#.Devicename$)
Addstring ADD$("Treiber-Version : ",Str$(DevmodeInput#.dmDriverVersion%))
Addstring ADD$("Devmode-Size : ",Str$(DevmodeInput#.dmSize%))
Addstring ADD$("Treiber-Extra-Bytes : ",Str$(DevmodeInput#.dmDriverExtra%))
Addstring ADD$("Devmode-Fields : ",Hex$(DevmodeInput#.dmFields&))
Case @AND(DevmodeInput#.dmFields&,1) : Addstring "  - DM_ORIENTATION"
Case @AND(DevmodeInput#.dmFields&,2) : Addstring "  - DM_OUT_BUFFER"
Case @AND(DevmodeInput#.dmFields&,4) : Addstring "  - DM_PAPERLENGTH"
Case @AND(DevmodeInput#.dmFields&,8) : Addstring "  - DM_PAPERWIDTH"
Case @AND(DevmodeInput#.dmFields&,16) : Addstring "  - DM_SCALE"
Case @AND(DevmodeInput#.dmFields&,256) : Addstring "  - DM_COPIES"
Case @AND(DevmodeInput#.dmFields&,512) : Addstring "  - DM_DEFAULTSOURCE"
Case @AND(DevmodeInput#.dmFields&,1024) : Addstring "  - DM_PRINTQUALITY"
Case @AND(DevmodeInput#.dmFields&,2048) : Addstring "  - DM_COLOR"
Case @AND(DevmodeInput#.dmFields&,4096) : Addstring "  - DM_DUPLEX"
Case @AND(DevmodeInput#.dmFields&,8192) : Addstring "  - DM_YRESOLUTION"
Case @AND(DevmodeInput#.dmFields&,32768) : Addstring "  - DM_COLLATE"
Case @AND(DevmodeInput#.dmFields&,65536) : Addstring "  - DM_FORMNAME"
Case @AND(DevmodeInput#.dmFields&,131072) : Addstring "  - DM_LOGPIXELS"
Case @AND(DevmodeInput#.dmFields&,262144) : Addstring "  - DM_BITSPERPEL"
Case @AND(DevmodeInput#.dmFields&,524288) : Addstring "  - DM_PELSWIDTH"
Case @AND(DevmodeInput#.dmFields&,1048576) : Addstring "  - DM_PELSHEIGHT"
Case @AND(DevmodeInput#.dmFields&,2097152) : Addstring "  - DM_DISPLAYFLAGS"
Case @AND(DevmodeInput#.dmFields&,4194304) : Addstring "  - DM_DISPLAYFREQUENCY"
Case @AND(DevmodeInput#.dmFields&,33554432) : Addstring "  - DM_ICMMETHOD"
Case @AND(DevmodeInput#.dmFields&,67108864) : Addstring "  - DM_ICMINTENT"
Case @AND(DevmodeInput#.dmFields&,134217728) : Addstring "  - DM_MEDIATYPE"
Case @AND(DevmodeInput#.dmFields&,268435456) : Addstring "  - DM_DITHERTYPE"


Case equ(DevmodeInput#.dmOrientation%,~DMORIENT_LANDSCAPE):Addstring "Orientierung : Landscape"
Case equ(DevmodeInput#.dmOrientation%,~DMORIENT_PORTRAIT):Addstring "Orientierung : Portrait"

St$= str$(DevmodeInput#.dmPaperSize%)
Nr& = Sendmessage(LB3&,$018F,-1,addr(st$))
Sendmessage(LB2&,$0189,nr&,Selstr#)
Addstring ADD$("Papierformat : ",string$(Selstr#,0))

Addstring ADD$(ADD$("Papierlnge : ",str$(DevmodeInput#.dmPaperLength%))," mm")
Addstring ADD$(ADD$("Papierbreite : ",str$(DevmodeInput#.dmPaperWidth%))," mm")
Addstring ADD$(ADD$("Skalierung : ",str$(DevmodeInput#.dmScale%))," %")
Addstring ADD$("Kopien : ",str$(DevmodeInput#.dmCopies%))

St$= str$(DevmodeInput#.dmDefaultSource%)
Nr& = Sendmessage(LB3&,$018F,-1,addr(st$))
Sendmessage(LB2&,$0189,nr&,Selstr#)
Addstring ADD$("Default-Source : ",String$(Selstr#,0))

Case equ(word(DevmodeInput#,58),65535):Addstring "Druckqualitt : Draft"
Case equ(word(DevmodeInput#,58),65534):Addstring "Druckqualitt : Low"
Case equ(word(DevmodeInput#,58),65533):Addstring "Druckqualitt : Medium"
Case equ(word(DevmodeInput#,58),65532):Addstring "Druckqualitt : High"
Case or(gt(word(DevmodeInput#,58),65535),lt(word(DevmodeInput#,58),65532)):\
addstring ADD$(ADD$("Druckqualitt : ",str$(word(DevmodeInput#,58)))," DPI")
Case equ(DevmodeInput#.dmColor%,~DMCOLOR_COLOR):Addstring "Farbdruck : Farbe"
Case equ(DevmodeInput#.dmColor%,~DMCOLOR_MONOCHROME):Addstring "Farbdruck : Graustufen"

Case equ(DevmodeInput#.dmDuplex%,~DMDUP_SIMPLEX):Addstring "Duplex : 1-seitig"
Case equ(DevmodeInput#.dmDuplex%,~DMDUP_VERTICAL):Addstring "Duplex : 2-seitig-vertikal"
Case equ(DevmodeInput#.dmDuplex%,~DMDUP_HORIZONTAL):Addstring "Duplex : 2-seitig-horizontal"
Addstring ADD$("Y-Auflsung : ",str$(DevmodeInput#.dmYResolution%))
Case equ(DevmodeInput#.dmTTOption%,~DMTT_BITMAP):Addstring "Truetype als : Bitmap"
Case equ(DevmodeInput#.dmTTOption%,~DMTT_DOWNLOAD):Addstring "Truetype als : Download"
Case equ(DevmodeInput#.dmTTOption%,~DMTT_SUBDEV):Addstring "Truetype als : Ersatz"
Case equ(DevmodeInput#.dmTTOption%,~DMTT_DOWNLOAD_OUTLINE):Addstring "Truetype als : Download-Outline"
Case equ(DevmodeInput#.dmCollate%,~DMCOLLATE_FALSE):Addstring "Collate : Nein"
Case equ(DevmodeInput#.dmCollate%,~DMCOLLATE_TRUE):Addstring "Collate : Ja"

Case equ(word(DevmodeInput#,132),~DMMEDIA_STANDARD):Addstring "Druckermedium : Normalpapier"
Case equ(word(DevmodeInput#,132),~DMMEDIA_GLOSSY):Addstring "Druckermedium : Glossy"
Case equ(word(DevmodeInput#,132),~DMMEDIA_TRANSPARENCY):Addstring "Druckermedium : Transparent"
Case gt(word(DevmodeInput#,132),~DMMEDIA_USER):Addstring "Druckermedium : Benutzerdefiniert"


SendMessage(LB&,$0184,0,0)
Movelisttolist (LB&)
Dispose DevmodeInput#
Dispose DevmodeOutput#
Dispose Printer#
Dispose Selstr#
EndProc
'
Proc GetPrinters
'Drucker im System ermitteln
'Parameter : Listboxhandle
Parameters LB&
Clearlist
Declare Section_name$,ReturnSize&,IniFile$,Returnname$,x%
Declare PName$,PDriver$,PPort$
Section_name$ = "DEVICES"
IniFile$      = "Win.ini"
Returnsize&   = 32767
Dim ReturnBuffer#,Returnsize&
GetPrivateProfileSection(ADDR(Section_name$),ReturnBuffer#,ReturnSize&,ADDR(IniFile$))
Whilenot x% = Returnsize&
        Returnname$ = String$(ReturnBuffer#,x%)
        Case returnname$ = "": Break
        Pname$   = Substr$(Returnname$,1,"=")'Name
        PDriver$ = Substr$(Substr$(Returnname$,1,","),2,"=")'Treiber
        PPort$   = Substr$(Substr$(Returnname$,2,","),1,"=")'Port
        AddString PName$+","+PDriver$+","+PPort$
        X% = X% + Len(Returnname$) +1
Endwhile
SendMessage(LB&,$0184,0,0)
Movelisttolist (LB&)
Dispose Returnbuffer#
EndProc
'
Proc ChangeStandardPrinter
'Standard-Drucker wechseln
Parameters F$
Declare IniFile$
IniFile$      = "Win.ini"
WRITEINI "Win.Ini","Windows","Device"=F$
SendMessage($FFFF,$001A,0,ADDR(IniFile$))'Win-Ini-Update
EndProc
